REM
REM    This file provide the AnalyseURL function, which allows to easily retrieve
REM    particular parts of a gopher URL.
REM
REM    Usage: Result (STRING) = AnalyseURL(URL AS STRING, token AS STRING)
REM
REM    Possible tokens are: "server", "port", "GopherType", "selector"
REM


FUNCTION AnalyseURL(UrlToAnalyse AS STRING, token AS STRING) AS STRING
  DIM AS STRING WorkString, CharBuff
  DIM AS INTEGER nRes, CurField, x
  DIM WorkArray(0 TO 4) AS STRING

  SELECT CASE UCASE(TRIM(token))
    CASE "SERVER"
      nRes = 1
    CASE "PORT"
      nRes = 2
    CASE "GOPHERTYPE"
      nRes = 3
    CASE "SELECTOR"
      nRes = 4
    CASE ELSE
      nRes = 0
  END SELECT

  WorkString = TRIM(UrlToAnalyse)

  IF LEN(WorkString) >= 9 THEN
    IF LCASE(LEFT(WorkString, 9)) = "gopher://" THEN WorkString = MID(WorkString, 10)
  END IF

  IF LEN(WorkString) > 0 THEN
    CurField = 1
    FOR x = 1 TO LEN(WorkString)
      CharBuff = MID(WorkString, x, 1)
      SELECT CASE CurField
        CASE 1
          SELECT CASE CharBuff
            CASE ":"
              CurField = 2
            CASE "/"
              CurField = 3
            CASE ELSE
              WorkArray(CurField) += LCASE(CharBuff)
          END SELECT
        CASE 2
          IF CharBuff = "/" THEN
              CurField = 3
            ELSE
              WorkArray(CurField) += (CharBuff)
          END IF
        CASE 3
          WorkArray(CurField) = CharBuff
          CurField = 4
        CASE 4
          WorkArray(CurField) += CharBuff
      END SELECT
    NEXT x
  END IF

  IF LEN(WorkArray(3)) = 0 THEN WorkArray(3) = "1"  ' If no URI provided, then the GopherType is 1 (directory)
  WorkArray(2) = TRIM(STR(VAL(WorkArray(2))))       ' Sanitaze a bit the given port
  IF VAL(WorkArray(2)) = 0 THEN WorkArray(2) = "70" ' Defaults to port 70 if no port specified, or invalid

  RETURN WorkArray(nRes)
END FUNCTION
