REM
REM  File loader for FDGOPHER
REM  // Loads a binary file into the FileBuffer() array //
REM

#INCLUDE ONCE "chisock/chisock.bi"
USING chi

PRIVATE SUB DisplayDownloadProgress(FileSize AS INTEGER)
  DIM AS STRING FormattedFilesize
  SELECT CASE FileSize
    CASE IS > 1073741824  ' 1024 * 1024 * 1024 = 1'073'741'824
      FormattedFilesize = "" & FORMAT(FileSize / 1073741824, "#.00") & " GiB"
    CASE IS > 1048576     ' 1024 * 1024 = 1'048'576
      FormattedFilesize = "" & FORMAT(FileSize / 1048576, "#.00") & " MiB"
    CASE IS > 1024
      FormattedFilesize = "" & FORMAT(FileSize / 1024, "#.00") & " KiB"
    CASE ELSE
      FormattedFilesize = "" & FileSize & " bytes"
  END SELECT
  ClearContentSpace()
  ThrowMsg("Downloading... [" + FormattedFilesize + "]")
END SUB

SUB LoadFile(ServerAddress AS STRING, ServerPort AS INTEGER, ServerSelector AS STRING, LocalFile AS BYTE = 0)
  ' LocalFile = 0  -->  retrieve file from network, at the specified server
  ' LocalFile = 1  -->  get file from local disk
  REDIM FileBuffer(1 TO 1024) AS UBYTE
  DIM AS DOUBLE LastRefreshedTime = TIMER
  FileSize = 0
  IF LocalFile = 0 THEN
      ThrowMsg("Connecting...")
      DIM AS socket sock
      VAR socket_result = sock.client(ServerAddress, ServerPort)
      IF (socket_result) <> 0 THEN QuitProgram("Network error: " + translate_error(socket_result))
      sock.put_line(ServerSelector)
      WHILE sock.is_closed() = 0 OR sock.length() > 0
        IF ABS(TIMER - LastRefreshedTime) > 0.33 THEN DisplayDownloadProgress(FileSize) : LastRefreshedTime = TIMER
        IF UBOUND(FileBuffer) = FileSize THEN REDIM PRESERVE FileBuffer(1 TO FileSize * 2) AS UBYTE
        FileSize += 1
        IF sock.get(FileBuffer(FileSize)) = 0 THEN FileSize -= 1
      WEND
      DisplayDownloadProgress(FileSize)
      SLEEP 1, 1    ' Let's wait for a CPU tick for fun
    ELSE
      DIM DataFileHandler AS INTEGER
      DataFileHandler = FREEFILE
      OPEN ServerSelector FOR BINARY AS #DataFileHandler
      WHILE FileSize < LOF(DataFileHandler)
        IF FileSize = UBOUND(FileBuffer) THEN REDIM PRESERVE FileBuffer(1 TO FileSize * 2) AS UBYTE
        FileSize += 1
        GET #DataFileHandler, FileSize, FileBuffer(FileSize)
      WEND
      CLOSE #1
  END IF
END SUB
